;****************************************************************************
;****************************************************************************
;*
;* c64_memory.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef C64_MEMORY_INC
%define C64_MEMORY_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef C64_MEMORY_NASM
global c64_memory_initialize
global c64_memory_exit
global c64_memory_save_snapshot
global c64_memory_load_snapshot
global c64_memory_reset
global c64_memory_read
global c64_memory_write
global ab__c64_ram
global ab__c64_character_rom
global ab__c64_color_ram
%else
extern c64_memory_initialize
extern c64_memory_exit
extern c64_memory_save_snapshot
extern c64_memory_load_snapshot
extern c64_memory_reset
extern c64_memory_read
extern c64_memory_write
extern ab__c64_ram
extern ab__c64_character_rom
extern ab__c64_color_ram
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
				struc c64_memory_data
				alignb 4
d__c64_memory_modul_id:		resd	1
				endstruc



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro C64_MEMORY_CALL_RESET 2
			mov	dword eax, %2
			mov	dword [%1 + d__c64_memory_modul_id], eax
			call	c64_memory_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

