;****************************************************************************
;****************************************************************************
;*
;* cia6526.inc
;*
;****************************************************************************
;****************************************************************************




%ifndef CIA6526_INC
%define CIA6526_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef CIA6526_NASM
global cia6526_initialize
global cia6526_exit
global cia6526_save_snapshot
global cia6526_load_snapshot
global cia6526_reset
global cia6526_cycle
global cia6526_dump
global cia6526_read
global cia6526_write
global cia6526_signal_pra
global cia6526_signal_prb
%else
extern cia6526_initialize
extern cia6526_exit
extern cia6526_save_snapshot
extern cia6526_load_snapshot
extern cia6526_reset
extern cia6526_cycle
extern cia6526_dump
extern cia6526_read
extern cia6526_write
extern cia6526_signal_pra
extern cia6526_signal_prb
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
				struc cia6526_data
				alignb 4
d__cia_modul_id:		resd	1
p__cia_execute_cycle:		resd	1
p__cia_execute_cycle_ta:	resd	1
p__cia_execute_cycle_tb:	resd	1
p__cia_link_irq:		resd	1
p__cia_link_pra:		resd	1
p__cia_link_prb:		resd	1
d__cia_state:			resd	1
d__cia_cycle_pipe_ta:		resd	1
d__cia_latch_ta:		resd	1
d__cia_counter_ta:		resd	1
d__cia_cycle_pipe_tb:		resd	1
d__cia_latch_tb:		resd	1
d__cia_counter_tb:		resd	1
b__cia_latch_pra:		resb	1
b__cia_signal_pra:		resb	1
b__cia_latch_prb:		resb	1
b__cia_signal_prb:		resb	1
ab__cia_registers:		resb	16
b__cia_irq_mask:		resb	1
				endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%assign CIA6526_PRA		000h
%assign CIA6526_PRB		001h
%assign CIA6526_DDRA		002h
%assign CIA6526_DDRB		003h
%assign CIA6526_TA_LO		004h
%assign CIA6526_TA_HI		005h
%assign CIA6526_TB_LO		006h
%assign CIA6526_TB_HI		007h
%assign CIA6526_TOD_10THS	008h
%assign CIA6526_TOD_SEC		009h
%assign CIA6526_TOD_MIN		00ah
%assign CIA6526_TOD_HR		00bh
%assign CIA6526_SDR		00ch
%assign CIA6526_ICR		00dh
%assign CIA6526_CRA		00eh
%assign CIA6526_CRB		00fh

%define CIA6526_MODUL_ID		byte edi + d__cia_modul_id
%define CIA6526_EXECUTE_CYCLE		byte edi + p__cia_execute_cycle
%define CIA6526_EXECUTE_CYCLE_TA	byte edi + p__cia_execute_cycle_ta
%define CIA6526_EXECUTE_CYCLE_TB	byte edi + p__cia_execute_cycle_tb
%define CIA6526_LINK_IRQ		byte edi + p__cia_link_irq
%define CIA6526_LINK_PRA		byte edi + p__cia_link_pra
%define CIA6526_LINK_PRB		byte edi + p__cia_link_prb
%define CIA6526_STATE			byte edi + d__cia_state
%define CIA6526_CYCLE_PIPE_TA		byte edi + d__cia_cycle_pipe_ta
%define CIA6526_LATCH_TA		byte edi + d__cia_latch_ta
%define CIA6526_COUNTER_TA		byte edi + d__cia_counter_ta
%define CIA6526_CYCLE_PIPE_TB		byte edi + d__cia_cycle_pipe_tb
%define CIA6526_LATCH_TB		byte edi + d__cia_latch_tb
%define CIA6526_COUNTER_TB		byte edi + d__cia_counter_tb
%define CIA6526_LATCH_PRA		byte edi + b__cia_latch_pra
%define CIA6526_SIGNAL_PRA		byte edi + b__cia_signal_pra
%define CIA6526_LATCH_PRB		byte edi + b__cia_latch_prb
%define CIA6526_SIGNAL_PRB		byte edi + b__cia_signal_prb
%define CIA6526_REGISTERS		byte edi + ab__cia_registers
%define CIA6526_IRQ_MASK		byte edi + b__cia_irq_mask



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro CIA6526_CALL_CYCLE 0-1
%if %0 > 0
			mov	dword edi, %1
%endif
;include the complete cycle routine here ?
;			call	dword [CIA6526_EXECUTE_CYCLE]
			call	cia6526_cycle
%endmacro



%macro CIA6526_CALL_RESET 5
			mov	dword edi, %1
			mov	dword eax, %2
			mov	dword ebx, %3
			mov	dword ecx, %4
			mov	dword edx, %5
			mov	dword [CIA6526_MODUL_ID], eax
			mov	dword [CIA6526_LINK_IRQ], ebx
			mov	dword [CIA6526_LINK_PRA], ecx
			mov	dword [CIA6526_LINK_PRB], edx
			call	cia6526_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

