;****************************************************************************
;****************************************************************************
;*
;* disc.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef DISC_INC
%define DISC_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef DISC_NASM
global disc_initialize
global disc_exit
global disc_save_snapshot
global disc_load_snapshot
global disc_reset
global disc_cycle
global disc_dump
global disc_signal_data
global disc_signal_rw
global disc_signal_byte_ready
global disc_signal_head
global disc_signal_speed
global disc_encode_d64
%else
extern disc_initialize
extern disc_exit
extern disc_save_snapshot
extern disc_load_snapshot
extern disc_reset
extern disc_cycle
extern disc_dump
extern disc_signal_data
extern disc_signal_rw
extern disc_signal_byte_ready
extern disc_signal_head
extern disc_signal_speed
extern disc_encode_d64
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
%assign DISC_LAST_TRACK		84
%assign DISC_TRACK_SIZE		02000h
%assign DISC_GCR_IMAGE_SIZE	(DISC_LAST_TRACK + 2) * DISC_TRACK_SIZE

				struc disc_data
				alignb 4
d__disc_modul_id:		resd	1
d__disc_state:			resd	1
d__disc_cycles_per_track:	resd	1
d__disc_bytes_per_track:	resd	1
d__disc_cycle_counter:		resd	1
d__disc_track_offset:		resd	1
ad__disc_speed_table:		resd	4
b__disc_track:			resb	1
b__disc_data_byte:		resb	1
b__disc_last_byte:		resb	1
b__disc_head_position:		resb	1
ab__disc_gcr_image:		resb	DISC_GCR_IMAGE_SIZE
				endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%define DISC_MODUL_ID		disc__vc1541 + d__disc_modul_id
%define DISC_STATE		disc__vc1541 + d__disc_state
%define DISC_CYCLES_PER_TRACK	disc__vc1541 + d__disc_cycles_per_track
%define DISC_BYTES_PER_TRACK	disc__vc1541 + d__disc_bytes_per_track
%define DISC_CYCLE_COUNTER	disc__vc1541 + d__disc_cycle_counter
%define DISC_TRACK_OFFSET	disc__vc1541 + d__disc_track_offset
%define DISC_SPEED_TABLE	disc__vc1541 + ad__disc_speed_table
%define DISC_TRACK		disc__vc1541 + b__disc_track
%define DISC_DATA_BYTE		disc__vc1541 + b__disc_data_byte
%define DISC_LAST_BYTE		disc__vc1541 + b__disc_last_byte
%define DISC_HEAD_POSITION	disc__vc1541 + b__disc_head_position
%define DISC_GCR_IMAGE		disc__vc1541 + ab__disc_gcr_image



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro DISC_CALL_CYCLE 0-1
			mov	dword eax, [DISC_CYCLE_COUNTER]
			cmp	dword eax, [DISC_CYCLES_PER_TRACK]
			jb	%%skip_cycle
			sub	dword eax, [DISC_CYCLES_PER_TRACK]
			push	dword eax
			call	disc_cycle
			pop	dword eax
%%skip_cycle:		add	dword eax, [DISC_BYTES_PER_TRACK]
			mov	dword [DISC_CYCLE_COUNTER], eax
%endmacro


%macro DISC_CALL_RESET 2
			mov	dword eax, %2
			mov	dword [%1 + d__disc_modul_id], eax
			call	disc_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

