;****************************************************************************
;****************************************************************************
;*
;* via6522.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef VIA6522_INC
%define VIA6522_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VIA6522_NASM
global via6522_initialize
global via6522_exit
global via6522_save_snapshot
global via6522_load_snapshot
global via6522_reset
global via6522_cycle
global via6522_dump
global via6522_read
global via6522_write
global via6522_signal_pb
global via6522_signal_pa
global via6522_signal_cb1
global via6522_signal_cb2
global via6522_signal_ca1
global via6522_signal_ca2
%else
extern via6522_initialize
extern via6522_exit
extern via6522_save_snapshot
extern via6522_load_snapshot
extern via6522_reset
extern via6522_cycle
extern via6522_dump
extern via6522_read
extern via6522_write
extern via6522_signal_pb
extern via6522_signal_pa
extern via6522_signal_cb1
extern via6522_signal_cb2
extern via6522_signal_ca1
extern via6522_signal_ca2
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
			struc via6522_data
			alignb 4
d__via_modul_id:	resd	1
p__via_link_irq:	resd	1
p__via_link_pb:		resd	1
p__via_link_cb2:	resd	1
p__via_link_pa:		resd	1
p__via_link_ca2:	resd	1
d__via_state:		resd	1
b__via_latch_pb:	resb	1
b__via_signal_pb:	resb	1
b__via_latch_pa:	resb	1
b__via_signal_pa:	resb	1
b__via_latch_t2_lo:	resb	1
ab__via_registers:	resb	16
b__via_irq_mask:	resd	1
			endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%assign VIA6522_PB	000h
%assign VIA6522_PA	001h
%assign VIA6522_DDRB	002h
%assign VIA6522_DDRA	003h
%assign VIA6522_T1C_LO	004h
%assign VIA6522_T1C_HI	005h
%assign VIA6522_T1L_LO	006h
%assign VIA6522_T1L_HI	007h
%assign VIA6522_T2C_LO	008h
%assign VIA6522_T2C_HI	009h
%assign VIA6522_SR	00ah
%assign VIA6522_ACR	00bh
%assign VIA6522_PCR	00ch
%assign VIA6522_IFR	00dh
%assign VIA6522_IER	00eh
%assign VIA6522_PA_NH	00fh	;PA no handshake

%define VIA6522_MODUL_ID	byte edi + d__via_modul_id
%define VIA6522_LINK_IRQ	byte edi + p__via_link_irq
%define VIA6522_LINK_PB		byte edi + p__via_link_pb
%define VIA6522_LINK_CB2	byte edi + p__via_link_cb2
%define VIA6522_LINK_PA		byte edi + p__via_link_pa
%define VIA6522_LINK_CA2	byte edi + p__via_link_ca2
%define VIA6522_STATE		byte edi + d__via_state
%define VIA6522_LATCH_PB	byte edi + b__via_latch_pb
%define VIA6522_SIGNAL_PB	byte edi + b__via_signal_pb
%define VIA6522_LATCH_PA	byte edi + b__via_latch_pa
%define VIA6522_SIGNAL_PA	byte edi + b__via_signal_pa
%define VIA6522_LATCH_T2_LO	byte edi + b__via_latch_t2_lo
%define VIA6522_REGISTERS	byte edi + ab__via_registers
%define VIA6522_IRQ_MASK	byte edi + b__via_irq_mask


;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VIA6522_CALL_CYCLE 0-1
%if %0 > 0
			mov	dword edi, %1
%endif
			call	via6522_cycle
%endmacro



%macro VIA6522_CALL_RESET 7
			mov	dword edi, %1
			mov	dword eax, %2
			mov	dword ebx, %3
			mov	dword ecx, %4
			mov	dword edx, %5
			mov	dword [VIA6522_MODUL_ID], eax
			mov	dword [VIA6522_LINK_IRQ], ebx
			mov	dword [VIA6522_LINK_PB], ecx
			mov	dword [VIA6522_LINK_CB2], edx
			mov	dword eax, %6
			mov	dword ebx, %7
			mov	dword [VIA6522_LINK_PA], eax
			mov	dword [VIA6522_LINK_CA2], ebx
			call	via6522_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

