;****************************************************************************
;****************************************************************************
;*
;* vic6569.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef VIC6569_INC
%define VIC6569_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef VIC6569_NASM
global vic6569_initialize
global vic6569_exit
global vic6569_reset
global vic6569_cycle
global vic6569_dump
global vic6569_read
global vic6569_write
global vic6569_signal_high_bits
global vic6569_center_screen
global vic6569_led1
global vic6569_led2
global vic6569_number1
%else
extern vic6569_initialize
extern vic6569_exit
extern vic6569_reset
extern vic6569_cycle
extern vic6569_dump
extern vic6569_read
extern vic6569_write
extern vic6569_signal_high_bits
extern vic6569_center_screen
extern vic6569_led1
extern vic6569_led2
extern vic6569_number1
%endif



;****************************************************************************
;* Module Data **************************************************************
;****************************************************************************
%define VIC6569_LINES			312
%define VIC6569_LINE_LENGTH		512

				struc vic6569_data
				alignb 4
d__vic_modul_id:		resd	1
p__vic_execute_bus_cycle:	resd	1
p__vic_execute_sequencer_cycle:	resd	1
d__vic_x_resolution:		resd	1
d__vic_x_padding:		resd	1
d__vic_y_resolution:		resd	1
p__vic_fb_address:		resd	1
d__vic_x_start:			resd	1
d__vic_x_end:			resd	1
d__vic_y_start:			resd	1
d__vic_y_end:			resd	1
p__vic_screen_start:		resd	1
p__vic_screen:			resd	1
p__vic_frame:			resd	1
d__vic_line_cycle:		resd	1
d__vic_line_counter:		resd	1
d__vic_line_latch:		resd	1
d__vic_high_bits:		resd	1
d__vic_video_counter:		resd	1
d__vic_video_counter_base:	resd	1
d__vic_row_counter:		resd	1
d__vic_cache_offset:		resd	1
d__vic_state:			resd	1
d__vic_border_left:		resd	1
d__vic_border_right:		resd	1
d__vic_border_top:		resd	1
d__vic_border_buttom:		resd	1
b__vic_bus_cycle_counter:	resb	1
b__vic_sequencer_cycle_counter:	resb	1
b__vic_dma_delay_counter:	resb	1
b__vic_video_byte:		resb	1
b__vic_color_ram_byte:		resb	1
b__vic_data_byte:		resb	1
ab__vic_color_lookup_table:	resb	4
ab__vic_video_cache:		resb	40
ab__vic_color_ram_cache:	resb	40
ab__vic_registers:		resb	47
ab__vic_frame_data:		resb	VIC6569_LINES * VIC6569_LINE_LENGTH
				endstruc



;****************************************************************************
;* assign's & defines's *****************************************************
;****************************************************************************
%define	VIC6569_MODUL_ID		vic6569__c64 + d__vic_modul_id
%define VIC6569_EXECUTE_BUS_CYCLE	vic6569__c64 + p__vic_execute_bus_cycle
%define VIC6569_EXECUTE_SEQUENCER_CYCLE	vic6569__c64 + p__vic_execute_sequencer_cycle
%define VIC6569_X_RESOLUTION		vic6569__c64 + d__vic_x_resolution
%define VIC6569_X_PADDING		vic6569__c64 + d__vic_x_padding
%define VIC6569_Y_RESOLUTION		vic6569__c64 + d__vic_y_resolution
%define VIC6569_FB_ADDRESS		vic6569__c64 + p__vic_fb_address
%define VIC6569_X_START			vic6569__c64 + d__vic_x_start
%define VIC6569_X_END			vic6569__c64 + d__vic_x_end
%define VIC6569_Y_START			vic6569__c64 + d__vic_y_start
%define VIC6569_Y_END			vic6569__c64 + d__vic_y_end
%define VIC6569_SCREEN_START		vic6569__c64 + p__vic_screen_start
%define VIC6569_SCREEN			vic6569__c64 + p__vic_screen
%define VIC6569_FRAME			vic6569__c64 + p__vic_frame
%define VIC6569_LINE_CYCLE		vic6569__c64 + d__vic_line_cycle
%define VIC6569_LINE_COUNTER		vic6569__c64 + d__vic_line_counter
%define VIC6569_LINE_LATCH		vic6569__c64 + d__vic_line_latch
%define VIC6569_HIGH_BITS		vic6569__c64 + d__vic_high_bits
%define VIC6569_VIDEO_COUNTER		vic6569__c64 + d__vic_video_counter
%define VIC6569_VIDEO_COUNTER_BASE	vic6569__c64 + d__vic_video_counter_base
%define VIC6569_ROW_COUNTER		vic6569__c64 + d__vic_row_counter
%define VIC6569_CACHE_OFFSET		vic6569__c64 + d__vic_cache_offset
%define VIC6569_STATE			vic6569__c64 + d__vic_state
%define	VIC6569_BORDER_LEFT		vic6569__c64 + d__vic_border_left
%define VIC6569_BORDER_RIGHT		vic6569__c64 + d__vic_border_right
%define VIC6569_BORDER_TOP		vic6569__c64 + d__vic_border_top
%define VIC6569_BORDER_BUTTOM		vic6569__c64 + d__vic_border_buttom
%define VIC6569_BUS_CYCLE_COUNTER	vic6569__c64 + b__vic_bus_cycle_counter
%define VIC6569_SEQUENCER_CYCLE_COUNTER	vic6569__c64 + b__vic_sequencer_cycle_counter
%define VIC6569_DMA_DELAY_COUNTER	vic6569__c64 + b__vic_dma_delay_counter
%define VIC6569_VIDEO_BYTE		vic6569__c64 + b__vic_video_byte
%define VIC6569_COLOR_RAM_BYTE		vic6569__c64 + b__vic_color_ram_byte
%define VIC6569_DATA_BYTE		vic6569__c64 + b__vic_data_byte
%define VIC6569_COLOR_LOOKUP_TABLE	vic6569__c64 + ab__vic_color_lookup_table
%define VIC6569_VIDEO_CACHE		vic6569__c64 + ab__vic_video_cache
%define VIC6569_COLOR_RAM_CACHE		vic6569__c64 + ab__vic_color_ram_cache
%define VIC6569_REGISTERS		vic6569__c64 + ab__vic_registers
%define VIC6569_FRAME_DATA		vic6569__c64 + ab__vic_frame_data



%assign VIC6569_DISPLAY_ENABLE	001h
%assign VIC6569_BORDER_VERT	002h
%assign	VIC6569_BORDER_MAIN	004h
%assign VIC6569_BAD_LINE	008h
%assign VIC6569_ACCESS_GRANTED	010h
%assign VIC6569_DISPLAY_MODE	020h
%assign VIC6569_RASTER_IRQ	040h



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro VIC6569_CALL_CYCLE 0-1
			call	dword [VIC6569_EXECUTE_SEQUENCER_CYCLE]
			call	dword [VIC6569_EXECUTE_BUS_CYCLE]
			cmp	byte  [VIC6569_DMA_DELAY_COUNTER], 0
			jz	%%skip
			dec	byte  [VIC6569_DMA_DELAY_COUNTER]
			jnz	%%skip
			or	dword [VIC6569_STATE], VIC6569_ACCESS_GRANTED
%%skip:
%endmacro



%macro VIC6569_CALL_RESET 2
			mov	dword eax, %2
			mov	dword [%1 + d__vic_modul_id], eax
			call	vic6569_reset
%endmacro



%endif
;********************************************* karsten.scheibler@bigfoot.de *

