;****************************************************************************
;****************************************************************************
;*
;* audio.inc
;*
;****************************************************************************
;****************************************************************************





%include "defines.inc"
%include "sys_calls.inc"
%include "write.inc"

%define AUDIO_NASM
%include "audio.inc"


section .data
d__samples_left:	dd	0
d__audio_handle:	dd	0

;****************************************************************************
;* audio_open ***************************************************************
;****************************************************************************
section .text
audio_open:
			;----
			;open
			;----

			SYS_OPEN  .cb__audio_device, O_WRONLY
			test	dword eax, eax
			js	near .open_error
			mov	dword [d__audio_handle], eax

			;-------
			;ioctl's
			;-------

			mov	dword ebx, .ad__ioctl_table
.loop:			mov	dword ecx, [ebx]
			test	dword ecx, ecx
			jz	.end
			add	dword ebx, 4
			mov	dword edx, ebx
			push	dword ebx
			SYS_IOCTL  [d__audio_handle]
			test	dword eax, eax
			js	near .ioctl_error
			pop	dword ebx
			add	dword ebx, 4
			jmp	.loop
.end:			ret

.cb__open_error:	db	"Error while opening audio device", 00ah
.open_error_length	equ	$ - .cb__open_error
.open_error:		push	dword eax
			WRITE_TEXT  .cb__open_error, .open_error_length
			jmp	.exit
.cb__ioctl_error:	db	"Error while ioctl on audio device", 00ah
.ioctl_error_length	equ	$ - .cb__ioctl_error
.ioctl_error:		push	dword eax
			WRITE_TEXT  .cb__ioctl_error, .ioctl_error_length
.exit:			pop	dword eax
			WRITE_HEX  8
			WRITE_RETURN
			SYS_EXIT
			ret

section .data
			align 4
.ad__ioctl_table:	dd	SOUND_PCM_RESET, NULL
			dd	SOUND_PCM_NONBLOCK, NULL
			dd	SOUND_PCM_WRITE_RATE, 44100
			dd	SOUND_PCM_WRITE_BITS, AFMT_S16_LE
			dd	SOUND_PCM_WRITE_CHANNELS, 1
			dd	SOUND_MIXER_WRITE_PCM, 04040h
			dd	SOUND_MIXER_WRITE_VOLUME, 04040h
			dd	0, 0

.cb__audio_device:	db	"/dev/dsp", 0



;****************************************************************************
;* audio_play ***************************************************************
;****************************************************************************
section .text
audio_play:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			mov	dword ecx, eax
			mov	dword edx, ebx
			SYS_WRITE  [d__audio_handle]
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret



;****************************************************************************
;* audio_samples_left *******************************************************
;****************************************************************************
section .text
audio_samples_left:	SYS_IOCTL  [d__audio_handle], SOUND_PCM_GETODELAY, d__samples_left
			ret



;****************************************************************************
;* audio_close **************************************************************
;****************************************************************************
section .text
audio_close:
			SYS_CLOSE  [d__audio_handle]
			ret
;********************************************* karsten.scheibler@bigfoot.de *

