;****************************************************************************
;****************************************************************************
;*
;* sync.nasm
;*
;****************************************************************************
;****************************************************************************





%include "sys_calls.inc"
%include "tty.inc"
%include "link.inc"

%define SYNC_NASM
%include "sync.inc"



;****************************************************************************
;* sync_new_frame ***********************************************************
;****************************************************************************
section .text
sync_new_frame:
			push	dword eax
			push	dword ebx
			push	dword ecx
			push	dword edx
			push	dword edi
			push	dword esi
			call	link_vc1541_led
			call	tty_get_character
			SYS_GETTIMEOFDAY  .timeval__end, 0
			cmp	byte  [.flag__start_present], 0
			jne	.start_time_present
			inc	byte  [.flag__start_present]
			jmp	.exit
.start_time_present:	mov	dword eax, [.timeval__end + d__timeval_usec]
			mov	dword ebx, [.timeval__end + d__timeval_sec]
			sub	dword eax, [.timeval__start + d__timeval_usec]
			jnc	.no_underflow
			add	dword eax, 1000000
			stc
.no_underflow:		sbb	dword ebx, [.timeval__start + d__timeval_sec]
			jne	.exit
			mov	dword ebx, 20000		;20ms
			sub	dword ebx, eax
			jc	.exit
			mov	dword eax, ebx
			mov	dword ebx, 1000
			mul	dword ebx
			mov	dword [.timespec__data + d__timespec_nsec], eax
			SYS_NANOSLEEP  .timespec__data, 0
.exit:			mov	dword eax, [.timeval__end + d__timeval_sec]
			mov	dword ebx, [.timeval__end + d__timeval_usec]
			mov	dword [.timeval__start + d__timeval_sec], eax
			mov	dword [.timeval__start + d__timeval_usec], ebx
			pop	dword esi
			pop	dword edi
			pop	dword edx
			pop	dword ecx
			pop	dword ebx
			pop	dword eax
			ret

section .data
			align 4
.timeval__start:	istruc timeval
			iend

.timeval__end:		istruc timeval
			iend

.timespec__data:	istruc timespec
			at d__timespec_sec, dd 0
			at d__timespec_nsec, dd 0
			iend

.flag__start_present:	db	0
;********************************************* karsten.scheibler@bigfoot.de *

