;****************************************************************************
;****************************************************************************
;*
;* write.inc
;*
;****************************************************************************
;****************************************************************************





%ifndef WRITE_INC
%define WRITE_INC

;****************************************************************************
;* Exported Symbols *********************************************************
;****************************************************************************
%ifdef WRITE_NASM
global write_text
global write_hex
global write_bin
global write_flag
global write_space
global write_return
%else
extern write_text
extern write_hex
extern write_bin
extern write_flag
extern write_space
extern write_return
%endif



;****************************************************************************
;* Macro's ******************************************************************
;****************************************************************************
%macro WRITE_TEXT 2
			mov	dword eax, %1
			mov	dword ebx, %2
			call	write_text
%endmacro



%macro WRITE_RETURN 0
			call	write_return
%endmacro



%macro WRITE_HEX 1-2
			mov	byte  bl, (%1 - 1)
%if %0 > 1
%if   %1 < 3
			mov	byte  al, %2
%elif %1 < 5
			mov	word  ax, %2
%elif %1 < 9
			mov	dword eax, %2
%else
%error "Too much Digits in WRITE_HEX"
%endif
%endif
			call	write_hex
%endmacro



%macro WRITE_BIN 1-2
			mov	byte  bl, (%1 - 1)
%if %0 > 1
%if   %1 < 9
			mov	byte  al, %2
%elif %1 < 17
			mov	word  ax, %2
%elif %1 < 33
			mov	dword eax, %2
%else
%error "Too much Digits in WRITE_BIN"
%endif
%endif
			call	write_bin
%endmacro



%macro WRITE_FLAG 1-2
			mov	byte  bl, (%1 - 1)
%if %0 > 1
%if   %1 < 9
			mov	byte  al, %2
%elif %1 < 17
			mov	word  ax, %2
%elif %1 < 33
			mov	dword eax, %2
%else
%error "Too much Digits in WRITE_FLAG"
%endif
%endif
			call	write_flag
%endmacro



%macro WRITE_SPACE 1
%if %1 > 8
%error "Too much Spaces in WRITE_SPACE"
%endif
			mov	dword eax, %1
			call	write_space
%endmacro

%endif
;********************************************* karsten.scheibler@bigfoot.de *

